Core Features

Advanced Features

JavaScript Data GridAccessing Rows

Version 36.2.0

This section covers the ways data can be accessed once it has been supplied to the grid.

Each time you pass data to the grid, the grid wraps each data item with a Row Node object. For example, if your data has 20 rows, the grid creates 20 Row Node objects, each Row Node wrapping one item of your data.

It is sometimes handy to access these Row Nodes. One example where it is handy is if you want to select a row, you can call rowNode.setSelected(true) to select it. This section details the different ways a Row Node can be accessed.

The following methods are provided for accessing the individual Row Nodes. A deeper explanation of these methods, along with examples, is provided further down.

Accessing Row Node API Methods Copy Link

getRowNodeCopy Link
Function
Returns the row node with the given ID. The row node ID is the one you provide from the callback getRowId(params), otherwise the ID is a number (cast as string) auto-generated by the grid when the row data is set. Special IDs for built-in row types (import constants from ag-grid-community):
  • ROOT_NODE_ID — the invisible root node (level -1, always a group)
  • GRAND_TOTAL_ROW_ID — the grand total footer row (when grandTotalRow is enabled)
  • GROUP_TOTAL_ROW_ID_PREFIX + groupId — a group total footer row for the group with the given ID
  • DETAIL_ROW_ID_PREFIX + masterRowId — the detail row for the master row with the given ID
  • forEachNodeCopy Link
    Function
    Iterates through each node (row) in the grid and calls the callback for each node. This works similar to the forEach method on a JavaScript array. This is called for every node, ignoring any filtering or sorting applied within the grid. It is not called on any pinned row nodes. If using the Infinite Row Model, then this gets called for each page loaded in the page cache.
    forEachNodeAfterFilterCopy Link
    Function
    Similar to forEachNode, except skips any filtered out data.
    forEachNodeAfterFilterAndSortCopy Link
    Function
    Similar to forEachNodeAfterFilter, except the callbacks are called in the order the rows are displayed in the grid.
    forEachLeafNodeCopy Link
    Function
    Similar to forEachNode, except lists all the leaf nodes. This effectively goes through all the data that you provided to the grid before the grid performed any grouping. If using tree data, goes through all the nodes for the data you provided, including nodes that have children, but excluding groups the grid created where gaps were missing in the hierarchy.

    Accessing Rows by Row ID Copy Link

    The easiest way to get a Row Node is by its Row ID. The ID is either provided by you using the grid callback getRowId(), or generated by the grid using an internal sequence.

    const gridOptions = {
        // callback tells the grid to use the 'id' attribute for IDs, IDs should always be strings
        getRowId: params => params.data.id,
    
        // other grid options ...
    }

    To lookup a Row Node use getRowNode() on the Grid API as follows:

    // get the row node with ID 55
    const rowNode = api.getRowNode('55');
    
    // do something with the row, e.g. select it
    rowNode.setSelected(true);

    Iterating Rows Copy Link

    Sometimes you may want to iterate through all the Row Nodes in the grid. This can be done using the grid's iteration APIs. The iteration APIs go through every Row Node, regardless of whether the Row Node is displayed or not. For example, if grouping and the group is closed, the group's children are not displayed by the grid, however the children are included in the iteration 'for-each' methods.

    // iterate through every node in the grid
    api.forEachNode((rowNode, index) => {
        console.log('node ' + rowNode.data.athlete + ' is in the grid');
    });
    
    // iterate only nodes that pass the filter
    api.forEachNodeAfterFilter((rowNode, index) => {
        console.log('node ' + rowNode.data.athlete + ' passes the filter');
    });
    
    // iterate only nodes that pass the filter and ordered by the sort order
    api.forEachNodeAfterFilterAndSort((rowNode, index) => {
        console.log('node ' + rowNode.data.athlete + ' passes the filter and is in this order');
    });
    
    // iterate through every leaf node in the grid
    api.forEachLeafNode((rowNode) => {
        console.log('node ' + rowNode.data.athlete + ' is not a group!');
    });

    All the methods above work with the Client-Side Row Model, i.e. the default Row Model. For all the other row models (i.e. Viewport, Infinite and Server-Side) the only method that is supported is api.forEachNode() and that will return back Row Nodes that are loaded into browser memory only (as each of these row models use a data source to lazy load rows).

    Example Using For-Each Methods Copy Link

    The example below shows the different For-Each API methods as follows:

    • For-Each Node: Prints out every row in the grid. It ignores filtering and sorting.
    • For-Each Node After Filter: Prints out every row in the grid, except those filtered out.
    • For-Each Node After Filter and Sort: Prints out every row in the grid, except those filtered, and in the same order they appear on the screen if sorting is applied.
    • For-Each Leaf Node: Prints out every row in the grid except group rows.

    In the example, try applying some sorts and filters, and see how this impacts the different operations in the developer console.

This section covers the ways data can be accessed once it has been supplied to the grid.
Each time you pass data to the grid, the grid wraps each data item with a Row Node object. For example, if your data has 20 rows, the grid creates 20 Row Node objects, each Row Node wrapping one item of your data.
It is sometimes handy to access these Row Nodes. One example where it is handy is if you want to select a row, you can call rowNode.setSelected(true) to select it. This section details the different ways a Row Node can be accessed.
The following methods are provided for accessing the individual Row Nodes. A deeper explanation of these methods, along with examples, is provided further down.
Accessing Row Node API Methods Copy Link
Returns the row node with the given ID.
The row node ID is the one you provide from the callback getRowId(params),
otherwise the ID is a number (cast as string) auto-generated by the grid when
the row data is set.
Special IDs for built-in row types (import constants from ag-grid-community):ROOT_NODE_ID — the invisible root node (level -1, always a group) GRAND_TOTAL_ROW_ID — the grand total footer row (when grandTotalRow is enabled) GROUP_TOTAL_ROW_ID_PREFIX + groupId — a group total footer row for the group with the given ID DETAIL_ROW_ID_PREFIX + masterRowId — the detail row for the master row with the given ID |
Iterates through each node (row) in the grid and calls the callback for each node.
This works similar to the forEach method on a JavaScript array.
This is called for every node, ignoring any filtering or sorting applied within the grid.
It is not called on any pinned row nodes.
If using the Infinite Row Model, then this gets called for each page loaded in the page cache. |
Similar to forEachNode, except skips any filtered out data. |
Similar to forEachNodeAfterFilter, except the callbacks are called in the order the rows are displayed in the grid. |
Similar to forEachNode, except lists all the leaf nodes.
This effectively goes through all the data that you provided to the grid before the grid performed any grouping.
If using tree data, goes through all the nodes for the data you provided, including nodes that have children,
but excluding groups the grid created where gaps were missing in the hierarchy. |
Accessing Rows by Row ID Copy Link
The easiest way to get a Row Node is by its Row ID. The ID is either provided by you using the grid callback getRowId(), or generated by the grid using an internal sequence.
<ag-grid-vue
:getRowId="getRowId"
/* other grid options ... */>
</ag-grid-vue>
// callback tells the grid to use the 'id' attribute for IDs, IDs should always be strings
this.getRowId = params => params.data.id;To lookup a Row Node use getRowNode() on the Grid API as follows:
// get the row node with ID 55
const rowNode = this.gridApi.getRowNode('55');
// do something with the row, e.g. select it
rowNode.setSelected(true); Iterating Rows Copy Link
Sometimes you may want to iterate through all the Row Nodes in the grid. This can be done using the grid's iteration APIs. The iteration APIs go through every Row Node, regardless of whether the Row Node is displayed or not. For example, if grouping and the group is closed, the group's children are not displayed by the grid, however the children are included in the iteration 'for-each' methods.
// iterate through every node in the grid
this.gridApi.forEachNode((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' is in the grid');
});
// iterate only nodes that pass the filter
this.gridApi.forEachNodeAfterFilter((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter');
});
// iterate only nodes that pass the filter and ordered by the sort order
this.gridApi.forEachNodeAfterFilterAndSort((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter and is in this order');
});
// iterate through every leaf node in the grid
this.gridApi.forEachLeafNode((rowNode) => {
console.log('node ' + rowNode.data.athlete + ' is not a group!');
});All the methods above work with the Client-Side Row Model, i.e. the default Row Model. For all the other row models (i.e. Viewport, Infinite and Server-Side) the only method that is supported is api.forEachNode() and that will return back Row Nodes that are loaded into browser memory only (as each of these row models use a data source to lazy load rows).
Example Using For-Each Methods Copy Link
The example below shows the different For-Each API methods as follows:
- For-Each Node: Prints out every row in the grid. It ignores filtering and sorting.
- For-Each Node After Filter: Prints out every row in the grid, except those filtered out.
- For-Each Node After Filter and Sort: Prints out every row in the grid, except those filtered, and in the same order they appear on the screen if sorting is applied.
- For-Each Leaf Node: Prints out every row in the grid except group rows.
In the example, try applying some sorts and filters, and see how this impacts the different operations in the developer console.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowNode,
ModuleRegistry,
NumberFilterModule,
RowApiModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelApiModule,
NumberFilterModule,
RowApiModule,
ClientSideRowModelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
const printNode = (node: IRowNode<IOlympicData>, index?: number) => {
if (node.group) {
console.log(index + " -> group: " + node.key);
} else {
console.log(
index + " -> data: " + node.data!.country + ", " + node.data!.athlete,
);
}
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div style="margin-bottom: 1rem">
<button v-on:click="onBtForEachNode()">For-Each Node</button>
<button v-on:click="onBtForEachNodeAfterFilter()">For-Each Node After Filter</button>
<button v-on:click="onBtForEachNodeAfterFilterAndSort()">For-Each Node After Filter and Sort</button>
<button v-on:click="onBtForEachLeafNode()">For-Each Leaf Node</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:groupDefaultExpanded="groupDefaultExpanded"
:rowData="rowData"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 180 },
{ field: "age" },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
filter: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const groupDefaultExpanded = ref(1);
const rowData = ref<IOlympicData[]>(null);
function onBtForEachNode() {
console.log("### api.forEachNode() ###");
gridApi.value!.forEachNode(printNode);
}
function onBtForEachNodeAfterFilter() {
console.log("### api.forEachNodeAfterFilter() ###");
gridApi.value!.forEachNodeAfterFilter(printNode);
}
function onBtForEachNodeAfterFilterAndSort() {
console.log("### api.forEachNodeAfterFilterAndSort() ###");
gridApi.value!.forEachNodeAfterFilterAndSort(printNode);
}
function onBtForEachLeafNode() {
console.log("### api.forEachLeafNode() ###");
gridApi.value!.forEachLeafNode(printNode);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data.slice(0, 50));
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
groupDefaultExpanded,
rowData,
onGridReady,
onBtForEachNode,
onBtForEachNodeAfterFilter,
onBtForEachNodeAfterFilterAndSort,
onBtForEachLeafNode,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}

This section covers the ways data can be accessed once it has been supplied to the grid.
Each time you pass data to the grid, the grid wraps each data item with a Row Node object. For example, if your data has 20 rows, the grid creates 20 Row Node objects, each Row Node wrapping one item of your data.
It is sometimes handy to access these Row Nodes. One example where it is handy is if you want to select a row, you can call rowNode.setSelected(true) to select it. This section details the different ways a Row Node can be accessed.
The following methods are provided for accessing the individual Row Nodes. A deeper explanation of these methods, along with examples, is provided further down.
Accessing Row Node API Methods Copy Link
Returns the row node with the given ID.
The row node ID is the one you provide from the callback getRowId(params),
otherwise the ID is a number (cast as string) auto-generated by the grid when
the row data is set.
Special IDs for built-in row types (import constants from ag-grid-community):ROOT_NODE_ID — the invisible root node (level -1, always a group) GRAND_TOTAL_ROW_ID — the grand total footer row (when grandTotalRow is enabled) GROUP_TOTAL_ROW_ID_PREFIX + groupId — a group total footer row for the group with the given ID DETAIL_ROW_ID_PREFIX + masterRowId — the detail row for the master row with the given ID |
Iterates through each node (row) in the grid and calls the callback for each node.
This works similar to the forEach method on a JavaScript array.
This is called for every node, ignoring any filtering or sorting applied within the grid.
It is not called on any pinned row nodes.
If using the Infinite Row Model, then this gets called for each page loaded in the page cache. |
Similar to forEachNode, except skips any filtered out data. |
Similar to forEachNodeAfterFilter, except the callbacks are called in the order the rows are displayed in the grid. |
Similar to forEachNode, except lists all the leaf nodes.
This effectively goes through all the data that you provided to the grid before the grid performed any grouping.
If using tree data, goes through all the nodes for the data you provided, including nodes that have children,
but excluding groups the grid created where gaps were missing in the hierarchy. |
Accessing Rows by Row ID Copy Link
The easiest way to get a Row Node is by its Row ID. The ID is either provided by you using the grid callback getRowId(), or generated by the grid using an internal sequence.
<ag-grid-angular
[getRowId]="getRowId"
/* other grid options ... */ />
// callback tells the grid to use the 'id' attribute for IDs, IDs should always be strings
this.getRowId = params => params.data.id;To lookup a Row Node use getRowNode() on the Grid API as follows:
// get the row node with ID 55
const rowNode = this.gridApi.getRowNode('55');
// do something with the row, e.g. select it
rowNode.setSelected(true); Iterating Rows Copy Link
Sometimes you may want to iterate through all the Row Nodes in the grid. This can be done using the grid's iteration APIs. The iteration APIs go through every Row Node, regardless of whether the Row Node is displayed or not. For example, if grouping and the group is closed, the group's children are not displayed by the grid, however the children are included in the iteration 'for-each' methods.
// iterate through every node in the grid
this.gridApi.forEachNode((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' is in the grid');
});
// iterate only nodes that pass the filter
this.gridApi.forEachNodeAfterFilter((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter');
});
// iterate only nodes that pass the filter and ordered by the sort order
this.gridApi.forEachNodeAfterFilterAndSort((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter and is in this order');
});
// iterate through every leaf node in the grid
this.gridApi.forEachLeafNode((rowNode) => {
console.log('node ' + rowNode.data.athlete + ' is not a group!');
});All the methods above work with the Client-Side Row Model, i.e. the default Row Model. For all the other row models (i.e. Viewport, Infinite and Server-Side) the only method that is supported is api.forEachNode() and that will return back Row Nodes that are loaded into browser memory only (as each of these row models use a data source to lazy load rows).
Example Using For-Each Methods Copy Link
The example below shows the different For-Each API methods as follows:
- For-Each Node: Prints out every row in the grid. It ignores filtering and sorting.
- For-Each Node After Filter: Prints out every row in the grid, except those filtered out.
- For-Each Node After Filter and Sort: Prints out every row in the grid, except those filtered, and in the same order they appear on the screen if sorting is applied.
- For-Each Leaf Node: Prints out every row in the grid except group rows.
In the example, try applying some sorts and filters, and see how this impacts the different operations in the developer console.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
IRowNode,
ModuleRegistry,
NumberFilterModule,
RowApiModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelApiModule,
NumberFilterModule,
RowApiModule,
ClientSideRowModelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div style="margin-bottom: 1rem">
<button (click)="onBtForEachNode()">For-Each Node</button>
<button (click)="onBtForEachNodeAfterFilter()">
For-Each Node After Filter
</button>
<button (click)="onBtForEachNodeAfterFilterAndSort()">
For-Each Node After Filter and Sort
</button>
<button (click)="onBtForEachLeafNode()">For-Each Leaf Node</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[groupDefaultExpanded]="groupDefaultExpanded"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 180 },
{ field: "age" },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
filter: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
groupDefaultExpanded = 1;
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onBtForEachNode() {
console.log("### api.forEachNode() ###");
this.gridApi.forEachNode(printNode);
}
onBtForEachNodeAfterFilter() {
console.log("### api.forEachNodeAfterFilter() ###");
this.gridApi.forEachNodeAfterFilter(printNode);
}
onBtForEachNodeAfterFilterAndSort() {
console.log("### api.forEachNodeAfterFilterAndSort() ###");
this.gridApi.forEachNodeAfterFilterAndSort(printNode);
}
onBtForEachLeafNode() {
console.log("### api.forEachLeafNode() ###");
this.gridApi.forEachLeafNode(printNode);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data.slice(0, 50)));
}
}
const printNode = (node: IRowNode<IOlympicData>, index?: number) => {
if (node.group) {
console.log(index + " -> group: " + node.key);
} else {
console.log(
index + " -> data: " + node.data!.country + ", " + node.data!.athlete,
);
}
};
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

This section covers the ways data can be accessed once it has been supplied to the grid.
Each time you pass data to the grid, the grid wraps each data item with a Row Node object. For example, if your data has 20 rows, the grid creates 20 Row Node objects, each Row Node wrapping one item of your data.
It is sometimes handy to access these Row Nodes. One example where it is handy is if you want to select a row, you can call rowNode.setSelected(true) to select it. This section details the different ways a Row Node can be accessed.
The following methods are provided for accessing the individual Row Nodes. A deeper explanation of these methods, along with examples, is provided further down.
Accessing Row Node API Methods Copy Link
Returns the row node with the given ID.
The row node ID is the one you provide from the callback getRowId(params),
otherwise the ID is a number (cast as string) auto-generated by the grid when
the row data is set.
Special IDs for built-in row types (import constants from ag-grid-community):ROOT_NODE_ID — the invisible root node (level -1, always a group) GRAND_TOTAL_ROW_ID — the grand total footer row (when grandTotalRow is enabled) GROUP_TOTAL_ROW_ID_PREFIX + groupId — a group total footer row for the group with the given ID DETAIL_ROW_ID_PREFIX + masterRowId — the detail row for the master row with the given ID |
Iterates through each node (row) in the grid and calls the callback for each node.
This works similar to the forEach method on a JavaScript array.
This is called for every node, ignoring any filtering or sorting applied within the grid.
It is not called on any pinned row nodes.
If using the Infinite Row Model, then this gets called for each page loaded in the page cache. |
Similar to forEachNode, except skips any filtered out data. |
Similar to forEachNodeAfterFilter, except the callbacks are called in the order the rows are displayed in the grid. |
Similar to forEachNode, except lists all the leaf nodes.
This effectively goes through all the data that you provided to the grid before the grid performed any grouping.
If using tree data, goes through all the nodes for the data you provided, including nodes that have children,
but excluding groups the grid created where gaps were missing in the hierarchy. |
Accessing Rows by Row ID Copy Link
The easiest way to get a Row Node is by its Row ID. The ID is either provided by you using the grid callback getRowId(), or generated by the grid using an internal sequence.
// callback tells the grid to use the 'id' attribute for IDs, IDs should always be strings
const getRowId = useCallback(params => params.data.id, []);
<AgGridReact getRowId={getRowId} />To lookup a Row Node use getRowNode() on the Grid API as follows:
// get the row node with ID 55
const rowNode = gridApi.getRowNode('55');
// do something with the row, e.g. select it
rowNode.setSelected(true); Iterating Rows Copy Link
Sometimes you may want to iterate through all the Row Nodes in the grid. This can be done using the grid's iteration APIs. The iteration APIs go through every Row Node, regardless of whether the Row Node is displayed or not. For example, if grouping and the group is closed, the group's children are not displayed by the grid, however the children are included in the iteration 'for-each' methods.
// iterate through every node in the grid
gridApi.forEachNode((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' is in the grid');
});
// iterate only nodes that pass the filter
gridApi.forEachNodeAfterFilter((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter');
});
// iterate only nodes that pass the filter and ordered by the sort order
gridApi.forEachNodeAfterFilterAndSort((rowNode, index) => {
console.log('node ' + rowNode.data.athlete + ' passes the filter and is in this order');
});
// iterate through every leaf node in the grid
gridApi.forEachLeafNode((rowNode) => {
console.log('node ' + rowNode.data.athlete + ' is not a group!');
});All the methods above work with the Client-Side Row Model, i.e. the default Row Model. For all the other row models (i.e. Viewport, Infinite and Server-Side) the only method that is supported is api.forEachNode() and that will return back Row Nodes that are loaded into browser memory only (as each of these row models use a data source to lazy load rows).
Example Using For-Each Methods Copy Link
The example below shows the different For-Each API methods as follows:
- For-Each Node: Prints out every row in the grid. It ignores filtering and sorting.
- For-Each Node After Filter: Prints out every row in the grid, except those filtered out.
- For-Each Node After Filter and Sort: Prints out every row in the grid, except those filtered, and in the same order they appear on the screen if sorting is applied.
- For-Each Leaf Node: Prints out every row in the grid except group rows.
In the example, try applying some sorts and filters, and see how this impacts the different operations in the developer console.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
AutoGroupColumnDef,
ClientSideRowModelApiModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
IRowNode,
ModuleRegistry,
NumberFilterModule,
RowApiModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelApiModule,
NumberFilterModule,
RowApiModule,
ClientSideRowModelModule,
ColumnMenuModule,
ContextMenuModule,
RowGroupingModule,
SetFilterModule,
];
const printNode = (node: IRowNode<IOlympicData>, index?: number) => {
if (node.group) {
console.log(index + " -> group: " + node.key);
} else {
console.log(
index + " -> data: " + node.data!.country + ", " + node.data!.athlete,
);
}
};
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", rowGroup: true, hide: true },
{ field: "athlete", minWidth: 180 },
{ field: "age" },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "sport", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
filter: true,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
50,
);
const onBtForEachNode = useCallback(() => {
console.log("### api.forEachNode() ###");
gridRef.current!.api.forEachNode(printNode);
}, [printNode]);
const onBtForEachNodeAfterFilter = useCallback(() => {
console.log("### api.forEachNodeAfterFilter() ###");
gridRef.current!.api.forEachNodeAfterFilter(printNode);
}, [printNode]);
const onBtForEachNodeAfterFilterAndSort = useCallback(() => {
console.log("### api.forEachNodeAfterFilterAndSort() ###");
gridRef.current!.api.forEachNodeAfterFilterAndSort(printNode);
}, [printNode]);
const onBtForEachLeafNode = useCallback(() => {
console.log("### api.forEachLeafNode() ###");
gridRef.current!.api.forEachLeafNode(printNode);
}, [printNode]);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div style={{ marginBottom: "1rem" }}>
<button onClick={onBtForEachNode}>For-Each Node</button>
<button onClick={onBtForEachNodeAfterFilter}>
For-Each Node After Filter
</button>
<button onClick={onBtForEachNodeAfterFilterAndSort}>
For-Each Node After Filter and Sort
</button>
<button onClick={onBtForEachLeafNode}>For-Each Leaf Node</button>
</div>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
groupDefaultExpanded={1}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
};